;
; Sample PECompact plugin.
; by Jeremy Collake
;
; PLUGIN TYPE: GetProcAddressHook
;
;
.486p
.model flat,STDCALL

public GetProcAddressHookPluginV2

include plugins.inc

.data
;
; NEVER attempt to use or reference data in the DATA section of this
; plugin! If you need data space, create it in the code section adjacent
; to the plugin code. Remember that you have the stack and the 
; resident data area available.
;
.code
start:	
DllEntry proc hInstDLL:DWORD, reason:DWORD, reserved1:DWORD 
	xor	eax,eax
	inc	eax
        ret 
DllEntry Endp 

;---------------------------------------------------------------------
;       PVOID GetProcAddressHookPluginV2(PFARPROC LoadLibaryA, 
;               PFARPROC GetProcAddress,
;               PVOID pResidentData,
;               ULONG nResidentDataSize,
;               HMODULE hModule,
;               LPCSTR pszApiName  // same ordinal rules as GetProcAddress param 
;               )   
;
; return value is address of API or zero if error.
;--------------------------------------------------------------------- 
GetProcAddressHookPluginV2 proc stdcall pLoadLibrary:DWORD,\
                pGetProcAddress:DWORD,\
                pResidentData:DWORD,\
                nResidentDataSize:DWORD,\
                hModule:DWORD,\
                pszApiName:DWORD 
                
                LOCAL   nR:DWORD                  ; example of a local variable
                                
                push    ebx
                push    edi
                push    esi
                
                ;
                ; use EBX as delta offset holder
                ;
                CALC_DELTA ebx
                               
                cmp     pLoadLibrary,0
                jz      PluginExitError
                cmp     pGetProcAddress,0
                jz      PluginExitError
                cmp     pResidentData,0
                jz      PluginExitError
                cmp     nResidentDataSize,0
                jz      PluginExitError
                cmp     hModule,0
                jz      PluginExitError
                cmp     pszApiName,0
                jz      PluginExitError
                
                ;
                ; go ahead and retrieve the requested import
                ;
                
                push    pszApiName
                push    hModule
                call    [pGetProcAddress]
                mov     nR,eax
                
                ;
                ; attempt to import MessageBoxA
                ;
                ; get module handle for user32
                lea     eax,szUser32[ebx]
                ;------------------
                push    eax
                call    [pLoadLibrary]
                ;------------------
                ; get address for MessageBoxA           
                lea     ecx,szMessageBoxA[ebx]                
                ;------------------
                push    ecx
                push    eax
                call    [pGetProcAddress]
                ;------------------                
                test    eax,eax
                jz      PluginExitError
                mov     pMessageBoxA[ebx],eax
                                
                ;
                ; attempt to write to resident data area                
                mov     edi,pResidentData               
                add     edi,4
                mov     eax,89909090h
                cmp     dword ptr [edi],eax
                jz      DoExit          ; already displayed msg                
                mov     dword ptr [edi],eax               
                                
                lea     eax,szGoodMsg[ebx]
                lea     ecx,szCaption[ebx]
                call    DoCallMsgBox
                jmp     DoExit
PluginExitError:
                lea     eax,szBadMsg[ebx]
                lea     ecx,szCaption[ebx]                
                call    DoCallMsgBox                
DoExit:                
                mov     eax,nR
                
                pop     esi
                pop     edi
                pop     ebx
                ret

DoCallMsgBox:
                push    0
                push    ecx
                push    eax
                push    0
                call    [pMessageBoxA+ebx]
                db      0c3h    ; don't put RET cuz you will confuse MASM                

;
; put any data here, in the procedure. You will have r+w+x access
; to this memory.
;
szUser32        db 'user32.dll',0
szMessageBoxA   db 'MessageBoxA',0
szGoodMsg       db 'GPA param test passed.',0
szBadMsg        db 'GPA param test failed.',0
szCaption       db 'GPA plugin.',0
pMessageBoxA    dd 0

GetProcAddressHookPluginV2 endp
;---------------------------------------------------------------------------
       
end start
ends

	