;
; Sample PECompact plugin.
; by Jeremy Collake
;
; PLUGIN TYPE: PostOperativePlugin
;
;
.486p
.model flat,STDCALL

public PostOperativePluginV2

include plugins.inc

.data
;
; NEVER attempt to use or reference data in the DATA section of this
; plugin! If you need data space, create it in the code section adjacent
; to the plugin code. Remember that you have the stack and the 
; resident data area available.
;
.code
start:	
DllEntry proc hInstDLL:DWORD, reason:DWORD, reserved1:DWORD 
	xor	eax,eax
	inc	eax
        ret 
DllEntry Endp 

;---------------------------------------------------------------------
;
; BOOL PostOperativePluginV2(PVOID pDeltaOffset,	
;               PFARPROC LoadLibaryA, 
;               PFARPROC GetProcAddress,
;               PVOID pResidentData,
;               ULONG nResidentDataSize,
;               )
;
;--------------------------------------------------------------------- 
PostOperativePluginV2 proc stdcall pLoadLibrary:DWORD,\
                pGetProcAddress:DWORD,\
                pResidentData:DWORD,\
                nResidentDataSize:DWORD
                
                ;
                ; use EBX as delta offset holder
                ;
                CALC_DELTA ebx
                               
                cmp     pLoadLibrary,0
                jz      PluginExitError
                cmp     pGetProcAddress,0
                jz      PluginExitError
                cmp     pResidentData,0
                jz      PluginExitError
                cmp     nResidentDataSize,0
                jz      PluginExitError
                
                ;
                ; attempt to import MessageBoxA
                ;
                ; get module handle for user32
                lea     eax,szUser32[ebx]
                ;------------------
                push    eax
                call    [pLoadLibrary]
                ;------------------
                ; get address for MessageBoxA           
                lea     ecx,szMessageBoxA[ebx]                
                ;------------------
                push    ecx
                push    eax
                call    [pGetProcAddress]
                ;------------------                
                test    eax,eax
                jz      PluginExitError
                mov     pMessageBoxA[ebx],eax
                
                ;
                ; attempt to write to resident data area                
                mov     edi,pResidentData               
                mov     dword ptr [edi],90909090h                
                                
                lea     eax,szGoodMsg[ebx]
                lea     ecx,szCaption[ebx]
                call    DoCallMsgBox
                jmp     DoExit
PluginExitError:
                lea     eax,szBadMsg[ebx]
                lea     ecx,szCaption[ebx]                
                call    DoCallMsgBox                
DoExit:                
                mov     eax,ERROR_SUCCESS
                ret

DoCallMsgBox:
                push    0
                push    ecx
                push    eax
                push    0
                call    [pMessageBoxA+ebx]
                db      0c3h    ; don't put RET cuz you will confuse MASM                

;
; put any data here, in the procedure. You will have r+w+x access
; to this memory.
;
szUser32        db 'user32.dll',0
szMessageBoxA   db 'MessageBoxA',0
szGoodMsg       db 'Post-op param test passed.',0
szBadMsg        db 'Post-op test failed.',0
szCaption       db 'Post-operative plugin.',0
pMessageBoxA    dd 0

PostOperativePluginV2 endp
;---------------------------------------------------------------------------
       
end start
ends

	